class Patient:
    """
    Beschreibung der Klasse Patient
    """
    def __init__(self, s):
        """
        Konstruktor des Patienten
        """
        self.name = s

    def InformationAusgeben(self):
        """
        Gibt Information über den Patienten aus.
        """
        print(self.name)

    def NameGeben(self):
        """
        Gibt den Namen des Patienten aus
        """
        return self.name


class Knoten:
    """
    Beschreibung der Klasse Knoten
    """
    def __init__(self, dneu):
        """
        Konstruktor des Knoten
        """
        self.nachfolger = None
        self.daten = dneu

    def HintenEinfügen(self, dneu):
        """
        Fügt ein Datenelement am Ende der Liste ein
        """
        if self.nachfolger:
            self.nachfolger.HintenEinfügen(dneu)
        else:
            self.nachfolger = Knoten(dneu)

    def NachfolgerSetzen(self, nf):
        """
        Nachfolger des Knoten setzen
        """
        self.nachfolger = nf

    def NachfolgerGeben(self):
        """
        Gibt den Nachfolger des Knoten aus.
        """
        return self.nachfolger

    def DatenelementGeben(self):
        """
        Gibt das Datenelement zurück
        """
        return self.daten

    def InformationAusgeben(self):
        """
        Gibt Information über das Datenelement aus.
        """
        self.daten.InformationAusgeben()


class Warteschlange:
    """
    Beschreibung der Warteschlange
    """
    def __init__(self):
        """
        Konstruktor der Warteschlange
        """
        self.anfang = None

    def HintenEinfügen(self, dneu):
        """
        Fügt ein neues Datenelement am Ende der Warteschlange ein.
        """
        if self.anfang:
            self.anfang.HintenEinfügen(dneu)
        else:
            self.anfang = Knoten(dneu)

    def Entfernen(self):
        """
        Entfernt den ersten Patient aus der Warteschlange und gibt ihn zurück.
        """
        if self.anfang:
            k = self.anfang
            self.anfang = self.anfang.NachfolgerGeben()
            return k.DatenelementGeben()
        return None

    def InformationAusgeben(self):
        """
        Gibt Information über die Warteschlange aus.
        """
        if self.anfang:
            self.anfang.InformationAusgeben()
            
    def AnfangGeben(self):
        """
        Gibt den Anfang zurück
        """
        return self.anfang
            
            
p1 = Patient("Andi")
p2 = Patient("Bert")
p3 = Patient("Clara")
w = Warteschlange()
    
w.HintenEinfügen(p1)
w.HintenEinfügen(p2)
w.HintenEinfügen(p3)

knoten = w.AnfangGeben()
while not knoten is None:
    knoten.InformationAusgeben()
    knoten = knoten.NachfolgerGeben()